#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <cmath>
#include <time.h>
#include "../lib/orga2.h" 
//The OpenCL C++ bindings, with exceptions
#define __CL_ENABLE_EXCEPTIONS
#include <CL/cl.hpp>

using namespace std;

int main(){
	try{
		unsigned int i;
		unsigned int n = 100;
		vector<cl::Platform> platforms;
		cl::Platform::get(&platforms);
		vector<cl::Device> devices;
		platforms.front().getDevices(CL_DEVICE_TYPE_GPU, &devices);
		cl::Context context(devices);
		cl::Device device = devices.front();
		cl::CommandQueue cmdQueue(context, device);
		cl::Buffer inputBuffer(context, CL_MEM_READ_WRITE, n*sizeof(cl_float));
		cl::Buffer outputBuffer(context, CL_MEM_READ_WRITE, n*sizeof(cl_float));
		//create some data
		vector<float> v_input(n,0);
		vector<float> v_output(n,0);
		forn(i,n) v_input[i] = i*i+0.5;

		cmdQueue.enqueueWriteBuffer(inputBuffer, false, 0, n*sizeof(cl_float), &v_input[0]);	//write buf 2 device main mem
		cmdQueue.enqueueReadBuffer(outputBuffer, false, 0, n*sizeof(cl_float), &v_output[0]);	//read to host mem from dev mem
		cmdQueue.finish();	//wait to finish all the transfers

	} catch (cl::Error& err){
	  clErr(err);
	  return -1;
	}
}
