#ifndef H_ORGA2
#define H_ORGA2
#define NUM_TESTS 10
#define VECTOR_MAX_SIZE 10000000
#define VECTOR_STEP 250000
#define NUMERICAL_ERROR 0.001 //relative error
#define WORK_GROUP_SIZE 256	//multiplo de 64 en amd; y de 32 en nvidia
#define forn(i,n) for(i = 0; i < n; i++)
#define tr(container, it) for(typeof(container.begin()) it = container.begin(); it != container.end(); it++)
#include <iostream>
#include <iomanip>
#include <fstream>
#include <stdio.h>
#include <cstdlib>
#include <ctime>
#include <sys/time.h>
#define __CL_ENABLE_EXCEPTIONS
#include <CL/cl.hpp>

enum timerOp {INIT, TOGGLE, FINISH};	
enum colType {GPU, CPU};

template<typename T> void printVector(const std::vector<T> &v){
	unsigned int i;
	std::cout << "[";
	forn(i, v.size()){
		std::cout << v[i];
		if(i < v.size() - 1) std::cout << ", ";
	}
	std::cout << "]";
}

void randomizeIntegerVector(std::vector<int> &v);
void randomizeFloatVector(std::vector<float> &v);
void randomizeIntegerMatrix(std::vector<std::vector<int> > &m);
void randomizeFloatMatrix(float *M, unsigned int n, unsigned int m);

void timerColNames(colType ct);
void timer(timerOp op);

void clErr(cl::Error& err);
void checkErr(cl_int err, const char * errStr);
const char* errorString(cl_int error);
void showIntMatrix(int n, int m, int *A);
void showFloatMatrix(float *A, unsigned int n, unsigned int m);
std::string convertToString(const char *filename);
unsigned int oneDimSize(int n);
#endif	
